/************************************************************************
 *                                                                      *
 *    Copyright (c) 1991 Wilhelm Valder, Regine Freitag, Wolfgang Dzida *
 *                        All rights reserved                           *
 *                                                                      *
 *                                                                      *
 *    Permission to copy this program or any part of this program is    *
 *    granted in case of personal, non-commercial use only. Any use     *
 *    for profit or other commercial gain without written permissions   *
 *    of the authors is prohibited.                                     *
 *                                                                      *
 *    You may freely distribute this program to friends, colleagues,    *
 *    etc.  As a courtesy we would appreciate it if you left our names  *
 *    on the code as the authors.                                       *
 *    We also, of course, disavow any liabilities                       *
 *    for any bizarre things you may choose to do with the system.      *
 *                                                                      *
 *    We would appreciate though your letting us know about any         *
 *    extensions, modifications, project suggestions, etc.              *
 *    Please mail all bugs, comments, complaints and suggestions to:    *
 *                                                                      *
 *                                                                      *
 *    GMD (German National Research Center for Computer Science)        *
 *    Institut fuer Systemtechnik (F2G2)                                *
 *    P.O. Box 1240                                                     *
 *    Schloss Birlinghoven                                              *
 *    D-5205 St. Augustin 1, West Germany                               *
 *                                                                      *
 *    email:    dzida@gmd.de                                            *
 *              freitag@gmd.de                                          *
 *                                                                      *
 ************************************************************************/
/******************************************************************************
 * This file contains the program to generate the system menus of the 
 * file-system browser; the generated application node "fm-functions" is 
 * stored in file "fm.menu".
 *****************************************************************************/

#include <exBasics.h>
#include <exErrors.h>
#include <exMenu.h>
#include "version.h"

static char SccsID[] = "@(#)makeMenus.c	1.5\t6/25/93";            /* sccs keyword */

extern buildTree(/* parms */);
extern cleanupDirWindows(/* parms */);
extern dupFile(/* parms */);
extern cpFile(/* parms */);
extern delFile(/* parms */);
extern commit(/* parms */);
extern editAttr(/* parms */);
extern fmAbort(/* parms */);
extern fmQuit(/* parms */);
extern listDirAny(/* parms */);
extern listDirFather(/* parms */);
extern listDirSel(/* parms */);
extern mvFile(/* parms */);
extern putCurrentNames(/* parms */);
extern putAllNames(/* parms */);
extern remDirWnd(/* parms */);
extern renFile(/* parms */);
extern selAll(/* parms */);
extern sortByAccess(/* parms */);
extern sortByMod(/* parms */);
extern sortByName(/* parms */);
extern sortBySize(/* parms */);
extern sortHorizontal(/* parms */);
extern sortVertical(/* parms */);
extern undelFile(/* parms */);
extern unrenFile(/* parms */);
extern unselAll(/* parms */);
extern selByGrep(/* parms */);
extern getFilePattern(/* parms */);
extern showFileAttributes(/* parms */);
extern makeDir(/* parms */);

Widget top;

main(argc, argv)
     int argc;
     char **argv;
{
  char str[500];
  MHmenu *mptr;
  MHitem *iptr;
  MHiReq *req;

  top = XtInitialize(NULL, "fm menus", (XrmOptionDescRec *) NULL, 
		     0, &argc, argv);

  initMDS();
  exInitLayout(XtDisplay(top));
  exInitMenus(XtDisplay(top));

  newApplicationNode("fm-functions");

  insertFunction(currentApplication(), buildTree, "buildTree");
  insertFunction(currentApplication(), cleanupDirWindows, "cleanupDirWindows");
  insertFunction(currentApplication(), cpFile, "cpFile");
  insertFunction(currentApplication(), delFile, "delFile");
  insertFunction(currentApplication(), commit, "commit");
  insertFunction(currentApplication(), editAttr, "editAttr");
  insertFunction(currentApplication(), fmAbort, "fmAbort");
  insertFunction(currentApplication(), fmQuit, "fmQuit");
  insertFunction(currentApplication(), listDirAny, "listDirAny");
  insertFunction(currentApplication(), listDirFather, "listDirFather");
  insertFunction(currentApplication(), listDirSel, "listDirSel");
  insertFunction(currentApplication(), mvFile, "mvFile");
  insertFunction(currentApplication(), remDirWnd, "remDirWnd");
  insertFunction(currentApplication(), renFile, "renFile");
  insertFunction(currentApplication(), selAll, "selAll");
  insertFunction(currentApplication(), sortByAccess, "sortByAccess");
  insertFunction(currentApplication(), sortByMod, "sortByMod");
  insertFunction(currentApplication(), sortByName, "sortByName");
  insertFunction(currentApplication(), sortBySize, "sortBySize");
  insertFunction(currentApplication(), sortHorizontal, "sortHorizontal");
  insertFunction(currentApplication(), sortVertical, "sortVertical");
  insertFunction(currentApplication(), undelFile, "undelFile");
  insertFunction(currentApplication(), unrenFile, "unrenFile");
  insertFunction(currentApplication(), unselAll, "unselAll");
  insertFunction(currentApplication(), dupFile, "dupFile");
  insertFunction(currentApplication(), selByGrep, "selByGrep");
  insertFunction(currentApplication(), getFilePattern, "getFilePattern");
  insertFunction(currentApplication(), showFileAttributes,"showFileAttributes");
  insertFunction(currentApplication(), putCurrentNames, "putSel");
  insertFunction(currentApplication(), putAllNames, "putSel");
  insertFunction(currentApplication(), makeDir, "makeDir");
 
/* ------------------------------------------------------------ */
  mptr = newMenu("quit");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr,MDS_CNT_EQ);
  setSelCnt(mptr,1);
  sprintf(str, "Option to quit the file-system browser.");
  mptr->m_hlp->hlpmsg = strCopy(str);

  iptr = newItem(mptr, "quit", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Quit the file-system browser.\nYou are asked\nif pending operations should be accomplished\nbefore quitting.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(fmQuit, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "abort", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Quit the file-system browser.\nAll pending operations are aborted.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(fmAbort, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

/* ------------------------------------------------------------ */
  mptr = newMenu("windows");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr,MDS_CNT_EQ);
  setSelCnt(mptr,1);
  sprintf(str, "Window specific options.");
  mptr->m_hlp->hlpmsg = strCopy(str);

  iptr = newItem(mptr, "remove window", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Remove the current directory window.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(remDirWnd, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "neat windows", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Align all directory windows.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(cleanupDirWindows, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

/*
  iptr = newItem(mptr, "version", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Display current version.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(dsplInWnd, VERSION, "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);
*/

/* ------------------------------------------------------------ */
  mptr = newMenu("directories");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr,MDS_CNT_EQ);
  setSelCnt(mptr,1);
  sprintf(str, "Directory-specific options.");
  mptr->m_hlp->hlpmsg = strCopy(str);


  iptr = newItem(mptr, "list directory", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "List the selected directories in separate directory windows.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(listDirSel, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "list father", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "List the father directory of the current directory\nin a separate directory window.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(listDirFather, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "goto directory", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "List a directory.\nYou are prompted to enter the name of the directory\nto be displayed.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(listDirAny, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "file pattern", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "List the files which contain a specified pattern in their names.\nYou are prompted to enter the desired pattern.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(getFilePattern, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "edit attributes", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Edit the attributes of the selected files.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(editAttr, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "show tree", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Display graphically the tree\nwhose root is the current directory.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(buildTree, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

/* ------------------------------------------------------------ */
  mptr = newMenu("files");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr,MDS_CNT_EQ);
  setSelCnt(mptr,1);
  sprintf(str, "File-specific options.");
  mptr->m_hlp->hlpmsg = strCopy(str);


  iptr = newItem(mptr, "delete file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Mark the selected files to be deleted.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(delFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "undelete file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Remove the delete-mark from the selected files.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(undelFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "rename file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Mark the selected files to be renamed.\nYou are prompted to enter a new name.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(renFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "unrename file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Remove the rename-mark from the selected files\nand revert to the original file name.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(unrenFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "move file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Move the selected files to another directory.\nYou are requested to point to the destination directory\nand click the left mouse button,\nso as to accomplish the move operation.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(mvFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "copy file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Copy the selected files into another directory.\nYou are requested to point to the destination directory\nand click the left mouse button,\nso as to accomplish the copy operation.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(cpFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "duplicate file", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Duplicate the selected files in the current directory.\nYou are requested to enter a new name for the duplicated file.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(dupFile, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "create directory", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Create a directory in the current directory.\nYou are prompted to enter a name for the created directory.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(makeDir, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "put names ... ", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Transfer the absolute path names of all selected files to the command editor.\nYou get a submenu which allows you to decide\nwhether this applies only to the current directory\nor to all displayed directories.\n(If you use the file-system browser stand-alone,\n the names of the selected file(s) are printed to stdout.)");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(reqViaMenu, "scope", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "commit", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Accomplish all pending delete and rename operations\nfor the marked files in the current directory.\nThe operations can subsequently not be undone.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(commit, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);


/* ------------------------------------------------------------ */
  mptr = newMenu("display");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr,MDS_CNT_EQ);
  setSelCnt(mptr,1);
  sprintf(str, "Options for a different presentation of the files\nin the current directory.");
  mptr->m_hlp->hlpmsg = strCopy(str);


  iptr = newItem(mptr, "select all", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Select all files in the current directory.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(selAll, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "unselect all", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Unselect all files in the current directory.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(unselAll, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "select by grep", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Select all files that contain a specific pattern.\nYou are prompted to enter the string pattern.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(selByGrep, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);
  
  iptr = newItem(mptr, "order files", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Display the files in a specific order.\nYou get a submenu which allows you\nto request an order by name, access date,\nmodification date or file size.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(reqViaMenu, "order", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "horizontal mode", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Display files in horizontal order.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(sortHorizontal, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "vertical mode", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Display files in vertical order.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(sortVertical, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "show attributes", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Display the attributes of all selected files in a different window.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(showFileAttributes, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);


/* +++++++++++++++++++++++ sub menus +++++++++++++++++++++++++++ */

/* +++++++++++++++++++++++ scope +++++++++++++++++++++++++++ */

  mptr = newMenu("scope");
  setMenuType(mptr, MDS_M_POPUP);
  setSelType(mptr, MDS_CNT_EQ);
  setSelCnt(mptr, 1);
  sprintf(str, "Define scope of operation.");
  mptr->m_hlp->hlpmsg = strCopy(str);

  iptr = newItem(mptr, "curent window only", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Scope is the current window");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(putCurrentNames, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "all windows", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Scope is defined by all windows.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(putAllNames, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);
  
/* +++++++++++++++++++++++ order +++++++++++++++++++++++++++ */

  mptr = newMenu("order");
  setMenuType(mptr, MDS_M_POPUP);
  setSelType(mptr, MDS_CNT_EQ);
  setSelCnt(mptr, 1);
  sprintf(str, "Criteria for ordering the files in a directory window.");
  mptr->m_hlp->hlpmsg = strCopy(str);

  iptr = newItem(mptr, "file name", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Order files by name.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(sortByName, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "access date", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Order files by dates of last access.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(sortByAccess, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "modification date", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Order files by modification dates.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(sortByMod, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "file size", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Order files by size.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(sortBySize, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);


  setFile(currentApplication(), "fm.menu");
  dumpToFile(top);
  exit(0);
}

buildTree(/* parms */)
{
}

cleanupDirWindows(/* parms */)
{
}

cpFile(/* parms */)
{
}

dupFile(/* parms */)
{
}

delFile(/* parms */)
{
}

commit(/* parms */)
{
}

editAttr(/* parms */)
{
}

fmAbort(/* parms */)
{
}

fmQuit(/* parms */)
{
}

listDirAny(/* parms */)
{
}

listDirFather(/* parms */)
{
}

listDirSel(/* parms */)
{
}

mvFile(/* parms */)
{
}

remDirWnd(/* parms */)
{
}

renFile(/* parms */)
{
}

selAll(/* parms */)
{
}

sortByAccess(/* parms */)
{
}

sortByMod(/* parms */)
{
}

sortByName(/* parms */)
{
}

sortBySize(/* parms */)
{
}

sortHorizontal(/* parms */)
{
}

sortVertical(/* parms */)
{
}

undelFile(/* parms */)
{
}

unrenFile(/* parms */)
{
}

unselAll(/* parms */)
{
}

selByGrep(/* parms */)
{
}

getFilePattern(/* parms */)
{
}

showFileAttributes(/* parms */)
{
}

putCurrentNames(/* parms */)
{
}

putAllNames(/* parms */)
{
}

makeDir(/* parms */)
{
}
