/******************************************************************************
 * contains command tables for the macro editor
 *****************************************************************************/

static editCmd CmdTable [] = { 		/* define standard command set */
  {ctrl('a'), beglin}, 			/* beginning of line */
  {ctrl('b'), left}, 		       	/* cursor left  */
  {ctrl('d'), delnxt},	        	/* delete next character */
  {ctrl('e'), endlin},   	  	/* end of line */
  {ctrl('f'), right}, 		       	/* cursor right */
  {ctrl('j'), newline},                 /* split line */
  {ctrl('k'), krest},			/* delete to end of line */
  {ctrl('l'), newscr},   	        /* redraw screen */
  {ctrl('m'), newline},                 /* split line */
  {ctrl('n'), dwncol}, 			/* down in column */
  {ctrl('o'), openln},	  	     	/* open line above */
  {ctrl('p'), upcol}, 			/* up in column */
  {ctrl('r'), bwsearch},		/* search backward */
  {ctrl('s'), fsearch},			/* search forward */
  {ctrl('v'), dwnpage},   	    	/* forward page */
  {127,     delprev},   	        /* delete previous char */
  {EOS,     (int (*)()) 0},		/* end of list */
};		

static editCmd ctrlXCmds [] = {		       
  {ctrl('f'), findFile},		/* read in alternate file */
  {ctrl('i'), insertFile},		/* insert named file into buffer */
  {ctrl('s'), saveFile},		/* save buffer to current file */
  {ctrl('w'), writeFile},		/* write buffer to named file */
  {'k', killBuffer},			/* clear the current buffer */
  {'t', lineToTop},			/* current line to top of screen */
  {'?', help},				/* display help information */
  {EOS, (int (*)()) 0},		
};

static editCmd EscCmds [] = {
  {'<', topBuffer},			/* goto top of file */
  {'>', botBuffer},			/* goto bottom of file */
  {' ', goLine},			/* goto specified line */
  {'=', memory},			/* display statistics */
  {'b', wordl},				/* move to left word */
  {'d', fdelword},			/* delete next word */
  {'f', wordr},				/* move to right word */
  {'h', topscr},			/* cursor to top of display */
  {'l', botscr},			/* cursor to last line of display */
  {'m', midscr},			/* cursor near middle of display */
  {'n', upScroll},			/* scroll up */
  {'p', dwnScroll},			/* scroll down */
  {'r', bbsearch},			/* continue search backword */
  {'s', ffsearch},			/* continue search forward */
  {'v', uppage},			/* display previous page */
  {'w', wordr},				/* delete next word */
  {127, bdelword},			/* delete previous word */
  {EOS, (int (*)()) 0},		
};
